# BinarySearch.s
# 
# Demonstrates binary search on a fixed list of integers
	  .data		     # Data declaration section
array:  .word 	2,5,11,23,47,95,191,383,767,998
prompt: .asciiz	"\nInsert integer key (0 <= key): "
ymsg:   .asciiz	"\nKey was found at position "
nmsg:   .asciiz	"\nKey not found! "

	  .text
main:				      # Start of code section
	  la		$s0,array	# Put address of array in $s0
	  li		$s1,10	# Put count of elements in $s1
	  sll		$s1,$s1,2	# 4n byte = bytecount
input:  li		$v0,4		# Print_string function code
	  la		$a0,prompt  # Prompt for key
	  syscall
	  li		$v0,5		# Get key
	  syscall
	  bltz	$v0,exit	# Look for sentinal (negative)
	  move	$s2,$v0	# Put key in $s2
	  li		$t0,0		# $t0 = low = 0
	  sub		$t1,$s1,4	# $t1 = high = bytecount-4 (bytes)
loop:   bgt		$t0,$t1,fail# while( low <= high )
	  add		$t2,$t0,$t1 # $t2 = mid = low + high
	  sra		$t2,$t2,3   # mid = (low + high) / 8
	  sll		$t2,$t2,2	# mid = (low + high) / 2 (aligned)
        add		$t3,$t2,$s0 # get
	  lw        $t3,0($t3)  # array[mid]
	  blt		$t3,$s2,LH  # if (array[mid] < key)
	  blt		$s2,$t3,RH  # if (key < array[mid]
	  j		found
LH:	  add		$t0,$t2,4	# low = mid + 4 (bytes)
	  j		loop
RH:	  sub		$t1,$t2,4	# high = mid - 4 (bytes)
	  j		loop
# found 
found:  li		$v0,4		# Print
	  la		$a0,ymsg	# Label
	  syscall
	  sra		$t2,$t2,2	# bytes to indexes
	  add		$t2,$t2,1   # 1-based indexing
	  move	$a0,$t2	# Print
	  li	      $v0,1	      # Answer
	  syscall
	  j		input		# do it all again
# not found
fail:   li		$v0,4		# Print
	  la		$a0,nmsg	# Label
	  syscall
	  j		input
# exit
exit:	  li		$v0,10
	  syscall	  
	