# FibDP.s
# 
# Dynamic Programming implementation
####### INPUT:  ########
# 
##   non-negative integer n in $a0
##   (no test - negative values address locations outside array)
# 
####### OUTPUT: ###########
#
##   nth Fibonacci number in $v0
#
####### TO USE: ###########
# 
#	lw	$a0,n			// Put the n in $a0
#	jal	Fib			// Returns with sum in $v0
# 	
Fib:				# <- entry point
# save registers
	add	$sp,$sp,16
	sw	$a0,0($sp)
	sw	$s0,4($sp)
	sw	$s1,8($sp)
	sw	$ra,12($sp)
# check FibArray for answer
	mov	$s0,$a0	# take n
	sll	$s0,$s0,2	# multiply by 4 (bytes)
	la	$s1,FibArray    # get array address
	add	$s1,$s1,$s0	# actual location address
	lw	$v0,0($s1)	# what's there
	bnz	$v0,return	# if not zero, found it already
# otherwise we have to actually do the calculation
# adjust input parameter
	sub	$a0,$a0,1	# n-1 new argument
	jal	Fib		# first recursive call
	mov	$s0,$v0	        # save result
	sub	$a0,$a0,1	# now use n-2 as argument
	jal	Fib		# second recursive call
	add	$v0,$v0,$s0	# new $v0 
	sw	$v0,0($s1)	# save it in FibArray
# restore registers
return:
	lw	$ra,12($sp)
	lw	$s1,8($sp)
	lw	$s0,4($sp)
	lw	$a0,0($sp)
	sub	$sp,$sp,16
	jr	$ra
	.data
FibArray:
	.word	    0		# Fib(0) = 0
	.word	    1		# Fib(1) = 1
	.word     1		# Fib(2) = 1
	.space  188		# room for 47 more
