# FibRecursive.s
# 
# recursive implementation
####### INPUT:  ########
# 
##   non-negative integer n in $a0
##   (no test - returns any negative integer)
# 
####### OUTPUT: ###########
#
##   nth Fibonacci number in $v0
#
####### TO USE: ###########
# 
#	lw	$a0,n		// Put the n in $a0
#	jal	Fib		// Returns with sum in $v0
# 	
Fib:				# ? entry point
# save registers
	sub	$sp,$sp,12	# \  push on stack
	sw	$a0,0($sp)	#  \ argument n (will be changed)
	sw	$s0,4($sp)	#  / changed register
	sw	$ra,8($sp)	# /  return address
# check for base case
	li	$s0,1
	ble	$a0,$s0,basecase # tests n <= 1
# adjust input parameter
	sub	$a0,$a0,1	# n-1 new argument
	jal	Fib		# first recursive call
	move	$s0,$v0	# save result
	sub	$a0,$a0,1	# now use n-2 as argument
	jal	Fib		# second recursive call
	add	$v0,$v0,$s0	# new $v0 
	j	return
basecase:
	li	$v0,$a0  	# Fib(n) = n for n <= 1
return: 
	lw	$ra,8($sp)	# \  put everything 
	lw	$s0,4($sp)	#  \ back the way 
      lw	$a0,0($sp)	#  / it was
	add	$sp,$sp,12	# /  done popping
	jr	$ra

