# LinkedList.s
# 
        .data                   # Data declaration section
title:  .asciiz   "\nLinked List Demonstration"
prompt: .ascii    "\nLinked List: " 
        .ascii    " 'P' = Print; " 
        .ascii    " 'I' = Insert;" 
        .ascii    " 'D' = Delete;" 
        .asciiz   " 'E' = Exit:  "
errmsg: .asciiz   "\nYou must reply with 'P', 'I', 'D', or 'E'! Try again"
imsg:   .asciiz   "\nWhat letter do you want inserted? "
dmsg:   .asciiz   "\nWhat letter do you want deleted? "
pmsg:   .asciiz   "\nThe Linked List now is as follows: \n\t"
header: .word     -1,0
emsg:   .asciiz   "\nThe List is Empty"
noinmsg: .asciiz  "\nThat letter does not appear in the list!" 
exitmsg: .asciiz  "\n\nGoodbye!"
# 
        .text
main:                           # Start of code section
        li        $v0,4
        la        $a0,title
        syscall	
        la        $s0,header    # Constant pointer to header
loop:                           # Main loop
        li        $v0,4
        la        $a0,prompt
        syscall
        li        $v0,12        # No MIPSter
        syscall
        beq       $v0,'P',Pcode
        beq       $v0,'p',Pcode # accept lower case also
        beq       $v0,'I',Icode
        beq       $v0,'i',Icode # accept lower case also 
        beq       $v0,'D',Dcode
        beq       $v0,'d',Dcode # accept lower case also
        beq       $v0,'E',Ecode
        beq       $v0,'e',Ecode # accept lower case also
        li        $v0,4
        la        $a0,errmsg    # Not P, I, D, or E
        syscall
        j         loop   
# 
Pcode:  lw        $t0,4($s0)    # Get pointer from header
        beqz      $t0,Empty     # Empty list
        li        $v0,4         # Label output
        la        $a0,pmsg
        syscall
Ploop:  li        $v0,11        # Print_char (no MIPSter)
        li        $a0,0x09      # Tab
        syscall
        lw        $a0,0($t0)    # Next data
        li        $v0,11        # Print_char (no MIPSter)
        syscall
        lw        $t0,4($t0)    # Get next pointer
        bnez      $t0,Ploop     # If not zero pointer continue
        j         loop          # Zero pointer, start over
# 
Icode:  li        $v0,4         # Prompt for input
        la        $a0,imsg
        syscall
        li        $v0,12        # Read_char (no MIPSter)
        syscall
        move      $s1,$v0       # save it
        li        $v0,9         # Malloc (Memory Allocation)
        li        $a0,8         # 8 bytes desired
        syscall                 # $v0 now contains the address
        lw        $t0,4($s0)    # Former header pointer
        sw        $s1,0($v0)    # Char saved in new first position
        sw        $t0,4($v0)    # Old header pointer in new 1st
        sw        $v0,4($s0)    # New pointer in header
        j         loop          # Insert done, start over
#
Dcode:  li        $v0,4         # Prompt for input
        la        $a0,dmsg
        syscall
        li        $v0,12        # Read_char (no MIPSter)
        syscall
        move      $s1,$v0       # save it
        lw        $t0,4($s0)    # Get pointer from header
        move      $t3,$s0       # Use $t3 for previous
# $t3 -> previous element; $s1 = character; $t0 -> next element
# find character in list:
floop:  beqz      $t0,NotIn     # Empty list
        lw        $t1,0($t0)    # get next character
        beq       $t1,$s1,found
        lw        $t3,4($t3)    # move pointer
        lw        $t0,4($t0)    # move pointer
        j         floop
found:  lw        $t2,4($t0)    # character's pointer
        sw        $t2,4($t3)    # previous points past now
        j         loop
#
Ecode: 
        li        $v0,4
        la        $a0,exitmsg
        syscall
        li        $v0, 10       # exits program
        syscall
# 
Empty:  li        $v0,4
        la        $a0,emsg
        syscall
        j         loop
NotIn:  li        $v0,4
        la        $a0,noinmsg
        syscall
        j         loop
	