# Pascal.s 
#
# SPIM code to print out the Pascal triangle 
# using recursion and DYNAMIC PROGRAMMING. 
#
# if (n==0 || k==0 || k == n) return 1; 
# else // 0 < k < n
# return C(n,k) = C(n-1,k) + C(n-1,k-1);
#
######  REGISTER USE:  ##################
#
#	$a0	pass n to C
#	$a1	pass k to C
#	$v0	C returns result
#
##	$s3	constant N
##	$s4	counter i  //for(i=1;i<=N;i++)
##	$s5	counter j  //for(j=0;j<=i;j++)
#
#     Note: index = (i*i+i+j+j)/2 (words; *4 bytes!)
#	
######################################### 
	.data
prompt: .asciiz "Pascal(int N);\nInput non-negative integer: "
output: .asciiz "\nThe Pascal Triangle\n"
newln:  .asciiz "\n"	# Can't use MIPSter if we use
tab:	.asciiz "\t"    # function 11 to print a character 
	.align  8
table:  .space  10000	# room for more than 50 levels
#########################################
	.text
main:
## Get input
## prompt for value of N   
    	li      $v0, 4        # system call for print_str   
     	la      $a0, prompt   # address of string to print    
    	syscall
# read and echo N
	li	$v0, 5	      # system call for read_integer
	syscall		      # N in $v0
  	move    $s3, $v0      # put fixed value in $s3
        li      $v0, 1        # system call for print_int
        move    $a0, $s3      # echo
	syscall
        jal     println
# label output   
     	li      $v0, 4        # system call for print_str    
    	la      $a0, output   # address of string to print    
    	syscall
#
# Right here should check for negative N 
#
# Print N=0 case:
 	li	$v0, 1
	la	$t0, table
	sw	$v0, 0($t0)   # start array
        li      $a0, 1       
	syscall
	jal	println
# setup outer loop (i)
	li	$s4, 1	      # i=1; initialized
iloop:  bgt	$s4, $s3, done# while(i<=N)
# setup inner loop (j)	
	li	$s5, 0	      # j=0; initialized
jloop:  bgt	$s5, $s4, next# while(j<=i)
	move    $a0, $s4
	move    $a1, $s5
	jal	C	      # returns with C(i,j) in $v0
	move    $a0, $v0
	li	$v0, 1	
	syscall		      # print it
	li	$v0, 4	      # print
	move    $t0, $a0      # (save $a0) 
	la	$a0, tab      # tab
	syscall	
        move    $a0, $t0      # (replace $a0)
	addi    $s5, 1	      # j+=1;
	j	jloop
next:	addi    $s4, 1	      # i+=1;
	jal	println
	j	iloop
done:
####   
     	li      $v0, 10       # Put the integer 10 into $v0   
     	syscall               # Return control to the OS 
####
println:	    # subroutine to println saving registers 
        sub     $sp, $sp, 8   #\ 
        sw      $a0, 0($sp)   # \  
        sw      $v0, 4($sp)   #  \  
        la      $a0, newln    #   \ 
        li      $v0, 4        #    > Print new line   
     	syscall               #   /    
        lw      $v0, 4($sp)   #  /    
        lw      $a0, 0($sp)   # /     
        add     $sp, $sp, 8   #/     
        jr      $ra           # return
##### Recursive function C(n,k) returned in $v0 <== The main idea
C:   		
	sub	$sp,$sp,20    # save $a0 = n and $a1 = k
	sw	$ra,0($sp)    # 
	sw	$a0,4($sp)    #
	sw	$a1,8($sp)    #
	sw	$s1,12($sp)   # also change s1 so save
        sw      $s2,16($sp)   # also change s2 so save
	blez    $a0,basecase  # base case n <= 0 
	blez    $a1,basecase  # base case k <= 0
	bge     $a0,$a1,basecase  # base case k >= n
# calculate index
	move    $s1, $a0      # \ 
	mult    $s1, $s1      #  \
	mflo    $s1           #   \
	add     $s1, $s1, $a0 #    > CALCULATE THE INDEX
	add	$s1, $s1, $a1 #   /
	add	$s1, $s1, $a1 #  /
	sll	$s1, $s1, 1   # / 
	la	$t0, table    # \ calculate
	add	$s1, $s1, $t0 # / pointer
	lw	$v0, 0($s1)   # look in table
	bnez    $v0, return   # if found - done
	sub	$a0,$a0,1     # decrease argument n
	jal	C	      # recursive call C(n-1,k)
	move    $s2,$v0	      # returned value in $v0
	sub	$a1,$a1,1     # decrease argument k
	jal	C	      # recursive call C(n-1,k-1)
	add	$v0,$v0,$s2   # now final answer in $v0
        sw      $v0, 0($s1)   # put it in the table
	j	return
basecase: li    $v0,1	      # return 1 for base cases
return:		
	lw	$s2,16($sp)   # put back everything
        lw      $s1,12($sp)
	lw	$a1,8($sp)
	lw	$a0,4($sp)
	lw	$ra,0($sp)
	add	$sp,$sp,20
	jr	$ra	      # return
