# calculate.s
#
# $a0 = first integer
# $a1 = second integer
# $a2 = operation (1=Add, 2=Subtract, 3=Multiply, 4=Divide)
# returns result of (first OP second) in $v0
# NO error checking
# 
	.data		# Data declaration section
JumpTable:	.word   ADD,SUB,MUL,DIV	# SPIM figures out where
	.text
calculate:				# ? Entry point
	sub	$sp,$sp,8		# \  Push registers
	sw	$t0,0($sp)		#  > which are changed
	sw	$t1,4($sp)		# /  onto the stack
	la	$t0,JumpTable	# Get address of JumpTable     *
	sub	$t1,$a2,1		# Zero-based addressing        *
	sll	$t1,$t1,2		# Multiply by 4 (bytes)        *
	add	$t0,$t0,$t1		# Address's location address   *
	lw	$t0,0($t0)        # Got actual address           *
	jr	$t0
# switch labels
ADD:  add	$v0,$a0,$a1		# Do the addition
	j	DONE
SUB:  sub	$v0,$a0,$a1		# Do the subtraction
	j 	DONE
MUL:  mul   $v0,$a0,$a1		# Do the multiplication
	j	DONE
DIV:  div   $v0,$a0,$a1		# Do the division
	j	DONE			# (See below)
# finished; return
DONE: lw	$t1,4($sp)		# \  Pop registers
	lw	$t0,0($sp)		#  > which were changed
	add	$sp,$sp,8		# /  off the stack
	jr	$ra			# return

