# countTest.s
# Driver for count program
# NOTE: The count will include the <CR> at the end since
# this driver program prompts for the string. Therefore
# we subtract one from returned value.
         .data
string:  .space   128
prompt:  .asciiz  "\nInput a string: "
answer:  .asciiz  "\nThe number of characters is: "
         .text
main:    la       $a0, prompt
         li       $v0, 4
         syscall
         la       $a0, string
         li       $v0, 8
         syscall                # $a0 -> input string
         jal      count         # $v0 = answer
         move     $s0, $v0      # save answer
         la       $a0, answer
         li       $v0, 4
         syscall
         move     $a0, $s0      # put it back
         sub      $a0, $a0, 1   # don't count <CR>
         li       $v0, 1
         syscall
         li       $v0, 10
         syscall

#################################################################
# The following SPIM code counts the number of characters in a 
# Null terminated string pointed to by (whose address is in) $a0  # and returns the integer count in $v0.
# 
# Equivalent C-type code:
#   int count(char*[] a0) {
#     int v0 = 0;
#     while (&a0[0] != '\0') { v0++; a0++; }
#     return v0; 
#   }
#################################################################
count:                           # ? entry point
         li      $v0, 0          # initialize counter
loop:    lb      $t0, 0($a0)     # load one character from memory
         beq     $t0, $0, done   # done if Null character('\0')
         addi    $v0, $v0, 1     # increment counter
         addi    $a0, $a0, 1     # increment pointer 
         j       loop            # repeat
done:    jr      $ra             # $v0 contains answer 
#################################################################
