# factorial.s 
# 
# recursive implementation
######  INPUT:  ##########
#
## non-negative integer n in $a0 
## (no check so caller must test)
#	
######  OUTPUT: ##########
#
## value of n! in $v0
#
########################## 
factorial:			# ? entry point
# save registers
      sub	$sp,$sp,12	# \  push on the stack
      sw	$ra,0($sp)	#  \ return address
      sw	$a0,4($sp)	#  / argument n (will be changed)
      sw	$s0,8($sp)	# /  changed register
# check for base case
      beqz      $a0,basecase    # n == 0
# adjust input parameter
      sub	$a0,$a0,1	# n-1 new argument
      jal	factorial	# recursive call puts answer in $v0
      lw	$s0,4($sp)	# load this call's n into $s0
      mult	$v0,$s0   	# assume $v0 has (n-1)!
      mflo	$v0		# put (small) n! into $v0
      j	        return	 
basecase:
      li	$v0,1		# 0! = 1
return: 
      lw	$s0,8($sp)	# \  put everything back
      lw	$a0,4($sp)	#  \ the way it was including
      lw	$ra,0($sp)	#  / the return address
      add	$sp,$sp,12	# /  done popping
      jr	$ra
