# geoseries_f.s	
# 
# SPIM code to print out the elements of a geometric series with 
# the floating point values of initial value a, ratio r and
# number of terms n read in.
#
# The series is a, ar, ar^2, ar^3, ... , ar^(n-1), a^n
# 
####
#	REGISTER USE:
#	$f12	current element - initialized to a and printable
# 
#	$f0	input area for syscall 6
# 
#	$f2	ratio r
# 
#	$s0	number n to be printed (actually n+1)
# 	
####
	.data
promp1: .asciiz "Input initial real (float) value: "
promp2: .asciiz "Input ratio real value: "
promp3: .asciiz "How many values to print: "
newln:  .asciiz "\n"
tab:    .asciiz "\t"
# 
	.text
main:
# 
# Get input
# 
# prompt for inital value
        li      $v0, 4        # system call for print_str
        la      $a0, promp1   # address of string to print
        syscall
# read initial value
        li      $v0, 6	      # system call for read_float
        syscall               # a in $f0
        mov.s   $f12, $f0     # put a in register $f12 
# prompt for ratio value
        li      $v0, 4        # system call for print_str
        la      $a0, promp2   # address of string to print
        syscall
# read ratio value
        li      $v0, 6        # system call for read_float
        syscall               # r in $f0
        mov.s   $f2, $f0      # put r in register $f2
# prompt for number value
        li      $v0, 4        # system call for print_str
        la      $a0, promp3   # address of string to print
        syscall
# read number value
        li      $v0, 5        # system call for read_int
        syscall               # n in $v0
        move    $s0, $v0      # put  nin register $s0
# initialize counter
        li      $t0, 0
# print initial value
        li      $v0, 1
        move    $a0, $t0
        syscall               # print count
        li      $v0, 4
        la      $a0, tab
        syscall               # print tab
        li      $v0, 2        # print_float function
        syscall               # a is in $f12
        jal	    println
        j       loop
####
# Loop with test at beginning (while)  
loop:   
        bge     $t0,$s0,endloop  # test end of loop
        add     $t0,$t0, 1    # increment counter
        li      $v0, 1
        move    $a0, $t0
        syscall               # print count
        li      $v0, 4
        la      $a0, tab
        syscall               # print tab
        mul.s   $f12,$f12,$f2	# next value in $f12
        li      $v0, 2        # print_float function
        syscall
        jal     println
        j       loop
endloop:
####
        li      $v0, 10       
        syscall               # Return control to the OS 
####
println:        # subroutine to println saving registers
        sub     $sp,$sp,8     #\
        sw      $a0,0($sp)    # \
        sw      $v0,4($sp)    #  \
        la      $a0,newln     #   \
        li      $v0,4         #    : Print new line
        syscall               #   /
        lw      $v0,4($sp)    #  /
        lw      $a0,0($sp)    # /
        add     $sp,$sp,8     #/
        jr      $ra           # return
####