# insertion.s
# Demonstrates insertion sort
	    .data		         # Data declaration section
array:    .space  100            # Room for 25 integers
prompt:   .asciiz "Input an integer (0 = EOF):"
result:   .asciiz "Sorted those integers were:\n"
LF:       .asciiz "\n"
###############
	    .text
main:			               # Start of code section
# initializations
          li      $s0,0          # index is zero
          li      $a1,0          # count is zero
# input loop
getnxt:   li      $v0,4          # print_str function 
          la      $a0,prompt     # what to print
          syscall
          li      $v0,5          # read_int function
          syscall
          beqz    $v0,donein     # branch if found zero
          sw      $v0,array+0($s0) # indexed array
          addi    $s0,$s0,4      # increment index by 1 word
          add     $a1,$a1,4      # increment count by 1 word
          j       getnxt         # go back for more input
donein:
# print the result string
          li      $v0,4          # print_str function
          la      $a0,result     # what to print
          syscall
## sort the integers ($a1 contains the count 4n bytes)
# C/C++/Java Code:
#	null insertion(int[] a, int n)
#	{	for (int i = 1;  i < n; i++)
#		{	temp = a[i];
#			j = i-1;
#			while (j >= 0 && temp < a[j])
#			{	a[j+1] = a[j];
#				j = j-1;
#			}
#			a[j+1] = temp;
#		}
#	}
##### Here is the actual sorting code ###########
          li      $s0,4     # use $s0 for i initalized to 1 word
iloop:    beq     $s0,$a1,idone  # test i loop (i < n)
          lw      $t0,array+0($s0)  # temp = a[i];
          sub  $s1,$s0,4  # use $s1 for j initalized to i-1 word
whilej:   bltz    $s1,jdone      # j >= 0 test
          lw      $t1,array+0($s1)  # put a[j] in $t1
          bge     $t0,$t1,jdone     # temp < a[j] test
          sw      $t1,array+4($s1)  # a[j+1] = a[j];
          sub     $s1,$s1,4      # j = j-1; bytes
          j       whilej         # continue while loop
jdone:    sw      $t0,array+4($s1)  # a[j+1] = temp;
          add     $s0,$s0,4      # increment i
          j       iloop
idone: 
##### the integers are now sorted ###############
# print them
          li      $s0,0          # use $s0 as counter
ploop:    bge     $s0,$a1,exit   # test i < n (still in $a1)
          li      $v0,1          # print_int function
          lw      $a0,array+0($s0)  # put integer in place
          syscall                # print it
          li      $v0,4          # print_str function
          la      $a0,LF         # put next on new line
          syscall                # print it
          add     $s0,$s0,4      # increment counter
          j       ploop          # do it again
exit:
          li $v0, 10             # exits program
          syscall
