# sumvector.s
# 
# recursive implementation
####### INPUT:  ########
# 
##   address of the array a in $a0
##   length (actual count) n of the array in $a1
##   if n <= 0, returns zero (only check)
# 
####### OUTPUT: ###########
#
##   sum of the elements in $v0
#
####### TO USE: ###########
# 
#	la	$a0, a	        // Put address of a in $a0
#	lw	$a1, n	        // Put the count in $a1
#	jal	sumvector	// Returns with sum in $v0
# 	
sumvector:			# <- entry point
# save registers
	sub	$sp,$sp,12	# \  push on stack
	sw	$a1,0($sp)	#  \ argument n (will be changed)
	sw	$s0,4($sp)	#  / changed register
	sw	$ra,8($sp)	# /  return address
# check for base case
	blez	$a1,basecase    # n == 0
# adjust input parameter
	sub	$a1,$a1,1	# count n-1 new argument
	jal	sumvector	# recursive call puts answer in $v0
	lw	$s0,0($sp)	# get this call's n
	sub	$s0,$s0,1	# zero based array
	sll	$s0,$s0,2	# multiply by four (bytes)
	add	$s0,$a0,$s0	# address of a[n-1]
	lw	$s0,0($s0)	# get a[n-1] itself
	add	$v0,$s0,$v0	# new $v0 
	j	return
basecase:
	li	$v0,0		# nothing to add
return: 
	lw	$ra,8($sp)	# \  put everything 
	lw	$s0,4($sp)	#  \ back the way 
      lw	$a1,0($sp)  #  / it was
	add	$sp,$sp,12	# /  done popping
	jr	$ra

